"""<title>tutorial on how to load tiles and levels with isovid.</title>

<p>you should go through the tilevid tutorials before you view these.  isovid
is just another vid interface.

<pre>$ leveledit isolevel.tga isotiles.tga isocodes.tga 32 64 --iso
C:\pgu\examples> python ../scripts/leveledit isolevel.tga isotiles.tga isocodes.tga 32 64 --iso</pre>

<p>the next time you run leveledit, you will not need to provide
the tiles, codes, and width and height of the tiles
"""

import pygame
from pygame.locals import *
pygame.init()
pygame.mouse.set_visible(True)
# the following line is not needed if pgu is installed
import sys; sys.path.insert(0, "..")

from pgu import isovid
from pgu import tilevid
import data
import math
import vector

SW,SH = 800, 600
TW,TH = 64,128

##This is the initialization function I created for
##the game.
##
##I use the tga_ methods to load up the tiles and level I created.
##::
def init():
    g = isovid.Isovid()
    
    g.screen = pygame.display.set_mode((SW,SH),SWSURFACE)
    idata = [
             
    ('disco',data.filepath('disco1.png'),(13,52))
    ]
    g.load_images(idata)
    g.tga_load_tiles(data.filepath('tilemap.png'),(TW,TH))
    g.tga_load_level(data.filepath('testlevel.tga'),1)
    spr = tilevid.Sprite(g.images['disco'],(33,63))
    g.player = spr
    g.sprites.append(spr)
    g.view.x, g.view.y = g.tile_to_view((33,63))
    #print g.view.x +400, g.view.y + 300
    g.view.x -= 400
    g.view.y -= 300


    return g
##
    
##This is the run function I created for the game.  In this example,
##the level is displayed, but there is no interaction (other than allowing the
##user to quit via ESC or the QUIT signal.
##::
def run(g): 
    g.quit = 0
    
    g.paint(g.screen)
    pygame.display.flip()
    t=0.0
    center = (34,63)
    while not g.quit:
        for e in pygame.event.get():
            if e.type is QUIT: g.quit = 1
            if e.type is KEYDOWN and e.key == K_ESCAPE: g.quit = 1
            if e.type is KEYDOWN:
              if e.key == K_UP:
                g.player.pos = vector.addvec(g.player.pos, (-0.5, 0))
              if e.key == K_DOWN:
                g.player.pos = vector.addvec(g.player.pos, (0.5, 0))
              if e.key == K_LEFT:
                g.player.pos = vector.addvec(g.player.pos, (0, 0.5))
              if e.key == K_RIGHT:
                
                g.player.pos = vector.addvec(g.player.pos, (0, -0.5))
            if e.type is MOUSEBUTTONDOWN:
              print "moose"
              print g.screen_to_tile(e.pos)
              center = g.screen_to_tile(e.pos)
              g.view.x, g.view.y = g.tile_to_view(center)
              g.view.x -= 400
              g.view.y -= 300
        
        g.screen.fill((0,0,0))
        g.loop()
        t+= 0.01
        updates = g.update(g.screen)

        #pygame.draw.circle(g.screen,(255,0,0),g.tile_to_screen(vector.addvec(center, vector.rad2vec(t))),25)
        pygame.display.update(updates)
##    
    
run(init())
